var Brainstorm = {
    init: function() {
	// Locate Brainstorm URL fields
	var inputs = document.getElementsByTagName('INPUT');
	for (var i = 0; i < inputs.length; i++) {
	    var input = inputs[i];

	    if (input.getAttribute('type') == 'text'
		&& input.className.match(/BrainstormURLField/)) {
		input.addEventListener('blur', Brainstorm.init, false);
		input.addEventListener('change', Brainstorm.update, false);

		Brainstorm.lookup(input);
	    }
	}
    },

    update: function(ev) {
	Brainstorm.lookup(this);
    },

    lookup: function(tag) {
	var url = tag.value;
	if (url == null || url == '')
	    return;

	Ajax("GET", "/brainstorm?idea=" + escape(url), Brainstorm.gotIdea,
	     tag);
    },

    cleanTag: function(tag) {
	var td = Brainstorm.findTD(tag);

	// Get rid of any errors
	var uls = td.getElementsByTagName('UL');
	for (var i = 0; i < uls.length; i++) {
	    var ul = uls[i];

	    if (ul.className.match(/errorlist/))
		ul.parentNode.removeChild(ul);
	}

	// Get rid of any info
	var ps = td.getElementsByTagName('P');
	for (var i = 0; i < ps.length; i++) {
	    var p = ps[i];

	    if (p.className.match(/result/))
		p.parentNode.removeChild(p);
	}
    },

    gotIdea: function(elem, tag) {
	Brainstorm.cleanTag(tag);

	if (elem.tagName == 'idea') {
	    Brainstorm.updateInfo(tag, elem);
	} else if (elem.tagName == 'errors') {
	    Brainstorm.updateErrors(tag, elem);
	}
    },

    findTD: function(tag) {
	while (tag && tag.tagName != 'TD') {
	    tag = tag.parentNode;
	}

	return tag
    },

    updateInfo: function(tag, elem) {
	var td = Brainstorm.findTD(tag);

	// Add result
	var p = document.createElement('P');
	p.className = 'result';

	var id = elem.getElementsByTagName('id')[0].textContent;
	var title = elem.getElementsByTagName('title')[0].textContent;

	var text = document.createTextNode("Idea #" + id + ": " + title);
	p.appendChild(text);

	td.insertBefore(p, tag);//.nextSibling);
    },

    updateErrors: function(tag, elem) {
	var td = Brainstorm.findTD(tag);

	// Add new errors
	var ul = document.createElement('UL');
	ul.className = 'errorlist';

	var errors = elem.getElementsByTagName('error');
	for (var i = 0; i < errors.length; i++) {
	    var error = errors[i];

	    var li = document.createElement('LI');
	    var text = document.createTextNode(error.textContent);
	    li.appendChild(text);
	    ul.appendChild(li);
	}

	td.insertBefore(ul, tag);
    },
};

window.addEventListener('load', Brainstorm.init, false);
